//+------------------------------------------------------------------+
//|                                             Donchian Channel.mq4 |
//|                                Copyright 2014, Vladimir Karputov |
//|                                            http://wmua.ru/slesar |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Vladimir Karputov"
#property link      "http://wmua.ru/slesar"
#property version   "1.00"
#property strict
#property indicator_chart_window
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 5
#property  indicator_color1  DodgerBlue
#property  indicator_color2  Gold
#property  indicator_color3  Crimson
#property  indicator_color4  DodgerBlue
#property  indicator_color5  Gold
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1
#property  indicator_width4  1
#property  indicator_width5  1
//---- indicator parameters
extern int  periods=50;
//---- indicator buffers
double     upper[];
double     lower[];
double     meder[];
double     upper2[];
double     lower2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,159);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,159);
//---- indicator buffers mapping
   SetIndexBuffer(0,upper);
   SetIndexBuffer(1,lower);
   SetIndexBuffer(2,meder);
   SetIndexBuffer(3,upper2);
   SetIndexBuffer(4,lower2);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Donchian Channel("+IntegerToString(periods)+")");
   SetIndexLabel(0,"Upper");
   SetIndexLabel(1,"Lower");
   SetIndexLabel(2,"Meder");
   SetIndexLabel(3,"Upper2");
   SetIndexLabel(4,"Lower2");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   double high,low;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- calculate values
   for(int i=limit-1;i>=0;i--)
     {
      high=iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,periods,i));
      low=iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,periods,i));
      upper[i]=high;
      lower[i]=low;
      meder[i]=(high+low)/2;
      if(i<Bars-2)
        {
         if(Close[i]>upper[i+2])
            upper2[i]=High[i];
         if(Close[i]<lower[i+2])
            lower2[i]=Low[i];
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+
